<?php

/*

Plugin Name: Dashboard Custom Menu

Plugin URI: http://matthewryanphoto.com/blog/?page_id=1303

Description:  This simple plugin allows admins to add quick menu items to the dashboard sidebar. If you find it useful, please feel free to <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=UMZ6JL7QE2LUG&lc=US&item_name=Dashboard%20Custom%20Menu&currency_code=USD&bn=PP%2dDonationsBF%3abtn_donate_SM%2egif%3aNonHosted">Donate</a>

Author: Matt McDaniel

Version: 1.0

Author URI: http://www.matthewryanphoto.com

*/





/*  Copyright 2009  Matt McDaniel

*/



$menuitem=get_option("custommenu-1");

if (strlen($menuitem) < 10) {

	update_option("custommenu-0", "Link Name||URL here (http://www.yourdomainhere.com)||10");

}



add_action('admin_menu', 'DashboardCustomMenu_menu');



function DashboardCustomMenu_menu() {

  add_menu_page('Custom Menu', 'Custom Menu', 10,'DashboardCustomMenu.php', 'DashboardCustomMenu_options');

	for ( $counter = 0; $counter <= 10; $counter += 1) {

		$menuitem=get_option("custommenu-".$counter);

		if (strlen($menuitem) > 10) {

			$menu = explode("||",get_option("custommenu-".$counter));

			add_submenu_page('DashboardCustomMenu.php', $menu[0], $menu[0], $menu[2], $menu[1]);

		}

	}

}



function DashboardCustomMenu_options() {















	/* Page Start */

	echo "

<div class='wrap'>

  <div id='icon-options-general' class='icon32'><br />

  </div>

  <h2>Dashboard Custom Menu Settings</h2>

  <form name='addlink' id='addlink' method='post' action=''>

    <div id='poststuff' class='metabox-holder has-right-sidebar'>

      <div id='side-info-column' class='inner-sidebar'>

        <div id='side-sortables' class='meta-box-sortables'>

          <div id='linksubmitdiv' class='postbox ' >

            <div class='handlediv' title='Click to toggle'><br />

            </div>

            <h3 class='hndle'><span>About this Plugin</span></h3>

            <div class='inside'>

              <div class='submitbox' id='submitlink'>

                <div id='minor-publishing'>

                  <div style='display:none;'>

                    <input type='submit' name='save' value='Save' />

                  </div>

                  <div id='minor-publishing-actions'>

                    <div id='preview-action'> </div>

                    <div class='clear'></div>

                  </div>

                  <div id='misc-publishing-actions'>

                    <div class='misc-pub-section misc-pub-section-last'>

                          <ul class='options' style='padding-left: 20px;'>

							<style>.options a {text-decoration:none;}</style>

							<li>Plugin by Matt McDaniel</li>";

							

							

if (function_exists(zip_open)) {

	$file = "dashboard-custom-menu";

			$lastupdate = get_option($file."-update");

		if (strlen($lastupdate )==0 || date("U")-$lastupdate > $lastupdate) {

			$pluginUpdate = file_get_contents('http://downloads.wordpress.org/plugin/'.$file.'.zip');

			$myFile = "../wp-content/uploads/cache-".$file.".zip";

			$fh = fopen($myFile, 'w') or die("can't open file");

			$stringData = $pluginUpdate;

			fwrite($fh, $stringData);

			fclose($fh);

			

			$zip = zip_open($myFile);

			while ($zip_entry = zip_read($zip)) {

				if (zip_entry_name($zip_entry) == $file."/".$file.".php") {$size = zip_entry_filesize($zip_entry);}

			}

			zip_close($zip);

			unlink($myFile);

			

			if ($size != filesize("../wp-content/plugins/".$file."/".$file.".php")) {?>    

	

				<li>This plugin is out of date. <a href='http://downloads.wordpress.org/plugin/<?php echo $file;?>.zip'>Please <strong>download</strong> the latest version.</a></li>

	

	<?php

		} 

		update_option($file."-update", date('U'));

}}

							

					echo "		</ul>

                    </div>

                  </div>

                </div>

                <div class='clear'></div>

              </div>

            </div>

          </div>

        </div>

      </div>

      <div id='post-body'>

        <div id='post-body-content'>



          <div id='addressdiv' class='stuffbox'>

            <h3>

              <label for='link_url'>Custom Menu</label>

            </h3>



            <div class='inside' style='font-size: 16px;'>";

	

	

	

	

	if (isset($_POST['Submit'])) {

		for ( $counter = 0; $counter <= 10; $counter += 1) {

			update_option("custommenu-".$counter, $_POST['name-'.$counter]."||".$_POST['url-'.$counter]."||".$_POST['security-'.$counter]);

		}

		echo "<div id='message' class='updated fade'><p><strong>Settings saved. Please <a href='admin.php?page=DashboardCustomMenu.php'>reload</a> for settings to take affect.</strong></p></div>";

	}

	

	?>

    <form method="post">

    <?php

	echo "<table>";

	echo "<tr>";

	echo "<td style='width: 200px;'><strong>Link Title</strong></td>";

	echo "<td style='width: 300px;'><strong>Hyperlink</strong></td>";

	echo "<td style='width: 100px;'><strong>Visible to</strong></td>";

	echo "</tr>";



	for ( $counter = 0; $counter <= 10; $counter += 1) {

	

		echo "<tr>";

		unset($menuitem);

		$menuitem=get_option("custommenu-".$counter);

		if (strlen($menuitem) > 5) {

			$menu = explode("||",get_option("custommenu-".$counter));

		}

		

		echo "<td><input type='text' name='name-$counter' id='name-$counter' value='".$menu[0]."' style='width: 150px;'></td>";

		echo "<td><input type='text' name='url-$counter' id='url-$counter'  value='".$menu[1]."' style='width: 280px;'></td>";

		echo "<td><select name='security-$counter' id='security-$counter'>";

		

		echo "<option value='10'";

		if (!$menu[2] && $a == 10) {echo ' selected';}

		echo ">Administrator</option>";

		echo "<option value='7'";

		if (!$menu[2] && $a == 7) {echo ' selected';}

		echo ">Editor</option>";

		echo "<option value='2'";

		if (!$menu[2] && $a == 2) {echo ' selected';}

		echo ">Author</option>";

		echo "<option value='1'";

		if (!$menu[2] && $a == 1) {echo ' selected';}

		echo ">Contributor</option>";

		if (!$menu[2] && $a == 0) {echo ' selected';}

		echo "<option value='0'";

		echo ">Subscriber</option>";





		echo "</select></td>";

		echo "</tr>";

	}

	echo "</table>";

	

	?>

    

    <p class="submit">

    <input type="submit" name="Submit" class="button-primary" value="Save Changes" />

    </p>

	</form>



    </div>

    </div>







    

   
    </div>

    </div>

    </div>

    </div>

    </div>

    </div>

</div>

<?php

}

?>